POST User
Some tooltip text!
• 12 minutes to read
• 12 minutes to read
POST /api/v1/User
Creates a new User
Calls the User agent service SaveUser. NsApiSlow threshold: 2000 ms.
Online Restricted: ## The User agent is not available in Online by default. User management is not allowed for partner apps.
Query String Parameters
| Parameter Name | Type | Description |
|---|---|---|
| $select | string | Optional comma separated list of properties to include in the result. Other fields are then nulled out to reduce payload size: "Name,department,category" Default = show all fields. |
POST /api/v1/User?$select=name,department,category/id
Request Headers
| Parameter Name | Description |
|---|---|
| Authorization | Supports 'Basic', 'SoTicket' and 'Bearer' schemes, depending on installation type. |
| X-XSRF-TOKEN | If not using Authorization header, you must provide XSRF value from cookie or hidden input field |
| Content-Type | Content-type of the request body: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded, application/json-patch+json, application/merge-patch+json |
| Accept | Content-type(s) you would like the response in: application/json, text/json, application/xml, text/xml, application/json-patch+json, application/merge-patch+json |
| Accept-Language | Convert string references and multi-language values into a specified language (iso2) code. |
| SO-Language | Convert string references and multi-language values into a specified language (iso2) code. Overrides Accept-Language value. |
| SO-Culture | Number, date formatting in a specified culture (iso2 language) code. Partially overrides SO-Language/Accept-Language value. Ignored if no Language set. |
| SO-TimeZone | Specify the timezone code that you would like date/time responses converted to. |
| SO-AppToken | The application token that identifies the partner app. Used when calling Online WebAPI from a server. |
Request Body: newEntity
The User to be saved.
| Property Name | Type | Description |
|---|---|---|
| AssociateId | Integer | Primary key |
| Name | String | Initials, UserId - also used as login name for on-site installations. Identifies user in archives. |
| Rank | Integer | Rank order |
| Tooltip | String | Tooltip or other description |
| LicenseOwners | Array | The restricted and unrestricted module licenses grouped by license owner. These module licenses are either assigned or unassigned to this user |
| Role | Role | Users role for role-based security. Determines permissions and access rights for the user. |
| UserGroup | UserGroup | The main user group that this user belongs to. |
| OtherGroups | Array | The other groups this user is a member of, apart from the main user group. |
| Person | Person | The person associated with this user. Detailed information about the user |
| Deleted | Boolean | If true, the user is retired and should have no rights, not appear in lists, etc. |
| Lastlogin | String | Last login date |
| Lastlogout | String | Last logout date |
| EjUserId | Integer | ID of the ej user record corresponding to this associate; 0 for associates that are not ej users |
| RequestSignature | String | ej users request signature |
| Type | String | User type: 1=InternalAssociate, 2=ResourceAssociate, 3=ExternalAssociate, 4=AnonymousAssociate, 5=SystemAssociate |
| IsPersonRetired | Boolean | True if the user is retired and should have no rights, not appear in lists, etc. |
| IsOnTravel | Boolean | True if the user is on travel. |
| Credentials | Array | List of credentials registered for this user. i.e. valid authentication methods. |
| UserName | String | User name, a.k.a. Login name. This might be an e-mail address. |
| TicketCategories | Array | Request Ticket Categories assigned to the user. |
| NickName | String | The unique nick name for this user. Used in Service as an alias, similar to Name/Initials. |
| WaitingForApproval | Boolean | The user is waiting for an administrator to approve/grant her/him access. |
| ExtraFields | Object | Deprecated: Use {SuperOffice.CRM.Services.User.CustomFields} instead. Extra fields added to the carrier. This could be data from Plug-ins, the foreign key system, external applications, etc. |
| CustomFields | Object | Udef + Extra fields added to the carrier. Extra fields as defined by changes to database schema + user-defined fields as defined by admin. Custom fields combines user defined fields and extra fields into one bucket. The individual {SuperOffice.CRM.Services.User.ExtraFields} and |
| PostSaveCommands | Array | Post custom commands the client should execute after save has completed. |
Response:
OK
| Response | Description |
|---|---|
| 200 | OK |
Response body: UserWithLinks
| Property Name | Type | Description |
|---|---|---|
| AssociateId | int32 | Primary key |
| Name | string | Initials, UserId - also used as login name for on-site installations. Identifies user in archives. |
| Rank | int32 | Rank order |
| Tooltip | string | Tooltip or other description |
| LicenseOwners | array | The restricted and unrestricted module licenses grouped by license owner. These module licenses are either assigned or unassigned to this user |
| Role | Role | Users role for role-based security. Determines permissions and access rights for the user. |
| UserGroup | UserGroup | The main user group that this user belongs to. Use MDO List name "usergroup" to get list items. |
| OtherGroups | array | The other groups this user is a member of, apart from the main user group. Use MDO List name "usergroup" to get list items. |
| Person | Person | The person associated with this user. Detailed information about the user Use MDO List name "person_new" to get list items. |
| Deleted | bool | If true, the user is retired and should have no rights, not appear in lists, etc. |
| Lastlogin | date-time | Last login date |
| Lastlogout | date-time | Last logout date |
| EjUserId | int32 | ID of the ej user record corresponding to this associate; 0 for associates that are not ej users |
| RequestSignature | string | ej users request signature |
| Type | string | User type: 1=InternalAssociate, 2=ResourceAssociate, 3=ExternalAssociate, 4=AnonymousAssociate, 5=SystemAssociate |
| IsPersonRetired | bool | True if the user is retired and should have no rights, not appear in lists, etc. |
| IsOnTravel | bool | True if the user is on travel. |
| Credentials | array | List of credentials registered for this user. i.e. valid authentication methods. |
| UserName | string | User name, a.k.a. Login name. This might be an e-mail address. |
| TicketCategories | array | Request Ticket Categories assigned to the user. Use MDO List name "ejCategory" to get list items. |
| NickName | string | The unique nick name for this user. Used in Service as an alias, similar to Name/Initials. |
| WaitingForApproval | bool | The user is waiting for an administrator to approve/grant her/him access. |
| ExtraFields | object | Deprecated: Use {SuperOffice.CRM.Services.User.CustomFields} instead. Extra fields added to the carrier. This could be data from Plug-ins, the foreign key system, external applications, etc. |
| CustomFields | object | Udef + Extra fields added to the carrier. Extra fields as defined by changes to database schema + user-defined fields as defined by admin. Custom fields combines user defined fields and extra fields into one bucket. The individual {SuperOffice.CRM.Services.User.ExtraFields} and UserDefinedFields properties are deprecated in favor of this combined collection. |
| PostSaveCommands | array | Post custom commands the client should execute after save has completed. |
| TableRight | TableRight | The carrier's table right |
| FieldProperties | object | Field property dictionary mapping field names to field access rights. |
| _Links | object |
Sample request
POST /api/v1/User
Authorization: Basic dGplMDpUamUw
Accept: application/json; charset=utf-8
Accept-Language: en
Content-Type: application/json; charset=utf-8
{
"AssociateId": 891,
"Name": "Reynolds LLC",
"Rank": 808,
"Tooltip": "quis",
"LicenseOwners": [
{
"Name": "Toy, Schamberger and Tremblay",
"Description": "Inverse cohesive strategy",
"RestrictedModuleLicenses": [
{},
{}
],
"UnrestrictedModuleLicenses": [
{},
{}
]
},
{
"Name": "Toy, Schamberger and Tremblay",
"Description": "Inverse cohesive strategy",
"RestrictedModuleLicenses": [
{},
{}
],
"UnrestrictedModuleLicenses": [
{},
{}
]
}
],
"Role": null,
"UserGroup": null,
"OtherGroups": [
{
"Value": "libero",
"Tooltip": "sunt",
"Id": 664,
"Rank": 902,
"Deleted": false
},
{
"Value": "libero",
"Tooltip": "sunt",
"Id": 664,
"Rank": 902,
"Deleted": false
}
],
"Person": null,
"Deleted": false,
"Lastlogin": "2002-09-19T14:34:02.856279+02:00",
"Lastlogout": "2003-10-17T14:34:02.856279+02:00",
"EjUserId": 650,
"RequestSignature": "explicabo",
"Type": "AnonymousAssociate",
"IsPersonRetired": false,
"IsOnTravel": true,
"Credentials": [
{
"Type": null,
"Value": "aliquid",
"DisplayValue": "ea"
},
{
"Type": null,
"Value": "aliquid",
"DisplayValue": "ea"
}
],
"UserName": "Abbott, Rolfson and Schowalter",
"TicketCategories": [
{
"Id": 949,
"Name": "Stoltenberg, Okuneva and Kessler",
"ToolTip": "Voluptate deserunt.",
"Deleted": true,
"Rank": 40,
"Type": "culpa",
"ChildItems": [
{},
{}
],
"IconHint": "animi",
"ColorBlock": 651,
"ExtraInfo": "pariatur",
"StyleHint": "mollitia",
"FullName": "Alverta Diego Schimmel III"
}
],
"NickName": "Fadel Inc and Sons",
"WaitingForApproval": true,
"ExtraFields": {
"ExtraFields1": "et",
"ExtraFields2": "sit"
},
"CustomFields": {
"CustomFields1": "minus",
"CustomFields2": "maiores"
},
"PostSaveCommands": [
{
"Name": "Murazik-Casper",
"DisplayName": "Renner-Luettgen",
"Description": "Re-contextualized discrete moderator",
"ToolTip": "Quia dolorem ut magni vitae omnis qui.",
"Actions": "Implicit",
"ActionData": "voluptas"
},
{
"Name": "Murazik-Casper",
"DisplayName": "Renner-Luettgen",
"Description": "Re-contextualized discrete moderator",
"ToolTip": "Quia dolorem ut magni vitae omnis qui.",
"Actions": "Implicit",
"ActionData": "voluptas"
}
]
}
Sample response
HTTP/1.1 200 OK
Content-Type: application/json; charset=utf-8
{
"AssociateId": 511,
"Name": "Zboncak, Hudson and Reilly",
"Rank": 648,
"Tooltip": "distinctio",
"LicenseOwners": [
{
"Name": "Rowe, Kihn and Rowe",
"Description": "Optimized dynamic database",
"RestrictedModuleLicenses": [
{},
{}
],
"UnrestrictedModuleLicenses": [
{},
{}
],
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.String",
"FieldLength": 117
}
}
},
{
"Name": "Rowe, Kihn and Rowe",
"Description": "Optimized dynamic database",
"RestrictedModuleLicenses": [
{},
{}
],
"UnrestrictedModuleLicenses": [
{},
{}
],
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.String",
"FieldLength": 117
}
}
}
],
"Role": null,
"UserGroup": null,
"OtherGroups": [
{
"Value": "consequatur",
"Tooltip": "magnam",
"Id": 318,
"Rank": 459,
"Deleted": false,
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 189
}
}
}
],
"Person": null,
"Deleted": true,
"Lastlogin": "2014-06-10T14:34:02.8619195+02:00",
"Lastlogout": "2008-02-08T14:34:02.8619195+01:00",
"EjUserId": 625,
"RequestSignature": "eos",
"Type": "AnonymousAssociate",
"IsPersonRetired": true,
"IsOnTravel": false,
"Credentials": [
{
"Type": null,
"Value": "laudantium",
"DisplayValue": "dolores",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 353
}
}
},
{
"Type": null,
"Value": "laudantium",
"DisplayValue": "dolores",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 353
}
}
}
],
"UserName": "Dicki Inc and Sons",
"TicketCategories": [
{
"Id": 533,
"Name": "Rippin Inc and Sons",
"ToolTip": "Et iure et.",
"Deleted": false,
"Rank": 493,
"Type": "ut",
"ChildItems": [
{},
{}
],
"IconHint": "et",
"ColorBlock": 894,
"ExtraInfo": "eligendi",
"StyleHint": "quod",
"FullName": "Mrs. Guiseppe Paolo Stamm",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 750
}
}
}
],
"NickName": "Stokes, Botsford and Langosh",
"WaitingForApproval": true,
"ExtraFields": {
"ExtraFields1": "ipsam",
"ExtraFields2": "est"
},
"CustomFields": {
"CustomFields1": "voluptatum",
"CustomFields2": "quam"
},
"PostSaveCommands": [
{
"Name": "Conn, Schmitt and Zulauf",
"DisplayName": "Harris, Roob and O'Hara",
"Description": "Organized client-server moderator",
"ToolTip": "Vitae assumenda magni molestiae sit eum.",
"Actions": "Implicit",
"ActionData": "omnis",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.String",
"FieldLength": 398
}
}
}
],
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.String",
"FieldLength": 236
}
},
"_Links": {
"Self": "https://www.example.com/api/v1/project/321",
"Archive": "https://www.example.com/api/v1/project"
}
}